package com.offline.music.task.player.ui.adapter

import android.content.Context
import android.content.Intent
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.bumptech.glide.Glide
import com.offline.music.task.player.ProApp
import com.offline.music.task.player.R
import com.offline.music.task.player.databinding.RealHumanVoiceLayoutBinding
import com.offline.music.task.player.db.bean.Audio
import com.offline.music.task.player.tools.util.convertMillisToMinutesAndSecondsString
import com.offline.music.task.player.tools.util.getAudioDurationFromAssets
import com.offline.music.task.player.ui.activity.PlayerActivity

class HomeRecommendAdapter(
    private val context: Context,
    private val pdfList: List<Audio>,
) :
    RecyclerView.Adapter<HomeRecommendAdapter.PDFViewHolder>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): PDFViewHolder {
        val binding =
            RealHumanVoiceLayoutBinding.inflate(LayoutInflater.from(context), parent, false)
        return PDFViewHolder(binding)
    }

    override fun onBindViewHolder(holder: PDFViewHolder, position: Int) {
        val audio = pdfList[position]
        holder.bind(audio)
        holder.itemView.setOnClickListener {
            val intent = Intent(context, PlayerActivity::class.java);
            intent.putExtra(PlayerActivity.KEY_DETAILS_AUDIO, audio)
            context.startActivity(intent)
        }
    }

    override fun getItemCount(): Int = pdfList.size

    inner class PDFViewHolder(private val binding: RealHumanVoiceLayoutBinding) :
        RecyclerView.ViewHolder(binding.root) {

        fun bind(audio: Audio) {
            binding.apply {
                Glide.with(context)
                    .load("file:///android_asset/${audio.image}")
                    .into(realImg)
                name.text = audio.name
                val s = getAudioDurationFromAssets(context, audio.file)
                desc.text = convertMillisToMinutesAndSecondsString(s)

                if (ProApp.currentPlayingAudio != null) {
                    if (ProApp.currentPlayingAudio?.file == audio.file) {
                        stateImg.setImageResource(R.drawable.playing_white_icon)
                        name.setTextColor(context.getColor(R.color.blue))
                        desc.setTextColor(context.getColor(R.color.blue))
                    } else {
                        stateImg.setImageResource(R.drawable.amin_item_play_icon)
                        name.setTextColor(context.getColor(R.color.white))
                        desc.setTextColor(context.getColor(R.color.white_60))
                    }
                }
            }
        }
    }
}